## openblas 0.3.9+ds

=== lapack/CMakeLists.txt ===

include_directories(${PROJECT_SOURCE_DIR})
include_directories(${PROJECT_BINARY_DIR})


set(LAPACK_SOURCES
  potrf/potrf_U_single.c
  potrf/potrf_L_single.c
  lauum/lauum_U_single.c
  lauum/lauum_L_single.c
)

# add a 'z' to filename for complex version
set(LAPACK_MANGLED_SOURCES
  getf2/getf2_k.c
  lauu2/lauu2_U.c
  lauu2/lauu2_L.c
  potf2/potf2_U.c
  potf2/potf2_L.c
)

# sources that need TRANS set
# this has a 'z' version
set(TRANS_SOURCES
  getrs/getrs_single.c
)

# sources that need UNIT set
# these do NOT have a z version
set(UNIT_SOURCES
  trtri/trtri_U_single.c
  trtri/trtri_L_single.c
)

# these have a 'z' version
set(UNIT_SOURCES2
  trti2/trti2_U.c
  trti2/trti2_L.c
)

GenerateNamedObjects("${LAPACK_SOURCES}")
GenerateNamedObjects("${LAPACK_MANGLED_SOURCES}" "" "" false "" "" false 3)

GenerateNamedObjects("laswp/generic/laswp_k_4.c" "" "laswp_plus" false "" ""  false 3)
GenerateNamedObjects("laswp/generic/laswp_k_4.c" "MINUS" "laswp_minus" false "" ""  false 3)

foreach (float_type ${FLOAT_TYPES})
GenerateNamedObjects("getrf/getrf_single.c" "UNIT" "getrf_single" false "" "" false ${float_type})
endforeach ()

# dynamic_arch laswp needs arch specific code ?
#foreach(TARGET_CORE ${DYNAMIC_CORE})
#      set(TSUFFIX "_${TARGET_CORE}")
#
#GenerateNamedObjects("laswp/generic/laswp_k_4.c" "" "laswp_plus" false "" ${TSUFFIX}  false 3)
#GenerateNamedObjects("laswp/generic/laswp_k_4.c" "MINUS" "laswp_minus" false "" ${TSUFFIX}  false 3)
#endforeach ()

if (USE_THREAD)

  if (USE_OPENMP)
    set(GETRF_SRC getrf/getrf_parallel_omp.c)
  else ()
    set(GETRF_SRC getrf/getrf_parallel.c)
  endif ()

  # these do not have 'z' versions
  set(PARALLEL_SOURCES
    lauum/lauum_U_parallel.c
    lauum/lauum_L_parallel.c
    potrf/potrf_U_parallel.c
    potrf/potrf_L_parallel.c
  )

  # this has a z version
  list(APPEND TRANS_SOURCES
    getrs/getrs_parallel.c
  )

  # these do NOT have a z version
  list(APPEND UNIT_SOURCES
    trtri/trtri_U_parallel.c
    trtri/trtri_L_parallel.c
  )

  foreach (float_type ${FLOAT_TYPES})
    GenerateNamedObjects("${GETRF_SRC}" "UNIT" "getrf_parallel" false "" "" false ${float_type})
  endforeach()

  GenerateNamedObjects("${PARALLEL_SOURCES}")
endif ()

foreach (float_type ${FLOAT_TYPES})
  if (${float_type} STREQUAL "COMPLEX" OR ${float_type} STREQUAL "ZCOMPLEX")
    foreach (trans_src ${TRANS_SOURCES})
      string(REGEX MATCH "[a-z]/([a-z]+_)([a-z]+)" op_name ${trans_src})
      string(REPLACE "/" "/z" ztrans_src ${trans_src})
      GenerateNamedObjects("${ztrans_src}" "TRANS=1" "${CMAKE_MATCH_1}N_${CMAKE_MATCH_2}" false "" "" false ${float_type})
      GenerateNamedObjects("${ztrans_src}" "TRANS=2" "${CMAKE_MATCH_1}T_${CMAKE_MATCH_2}" false "" "" false ${float_type})
      GenerateNamedObjects("${ztrans_src}" "TRANS=3" "${CMAKE_MATCH_1}R_${CMAKE_MATCH_2}" false "" "" false ${float_type})
      GenerateNamedObjects("${ztrans_src}" "TRANS=4" "${CMAKE_MATCH_1}C_${CMAKE_MATCH_2}" false "" "" false ${float_type})
    endforeach ()
  else ()
    GenerateCombinationObjects("${TRANS_SOURCES}" "TRANS" "N" "" 4 "" false ${float_type})
  endif ()
endforeach ()

GenerateCombinationObjects("${UNIT_SOURCES}" "UNIT" "N" "" 4)
GenerateCombinationObjects("${UNIT_SOURCES2}" "UNIT" "N" "" 0 "" "" 3)

add_library(lapack OBJECT ${OPENBLAS_SRC})

=== lapack/trtrs/Makefile ===
TOPDIR	= ../..
include ../../Makefile.system

SBLASOBJS = strtrs_UNU_single.$(SUFFIX) strtrs_UNN_single.$(SUFFIX) strtrs_UTU_single.$(SUFFIX) strtrs_UTN_single.$(SUFFIX) strtrs_LNU_single.$(SUFFIX) strtrs_LNN_single.$(SUFFIX) strtrs_LTU_single.$(SUFFIX) strtrs_LTN_single.$(SUFFIX)
DBLASOBJS = dtrtrs_UNU_single.$(SUFFIX) dtrtrs_UNN_single.$(SUFFIX) dtrtrs_UTU_single.$(SUFFIX) dtrtrs_UTN_single.$(SUFFIX) dtrtrs_LNU_single.$(SUFFIX) dtrtrs_LNN_single.$(SUFFIX) dtrtrs_LTU_single.$(SUFFIX) dtrtrs_LTN_single.$(SUFFIX)
QBLASOBJS = qtrtrs_UNU_single.$(SUFFIX) qtrtrs_UNN_single.$(SUFFIX) qtrtrs_UTU_single.$(SUFFIX) qtrtrs_UTN_single.$(SUFFIX) qtrtrs_LNU_single.$(SUFFIX) qtrtrs_LNN_single.$(SUFFIX) qtrtrs_LTU_single.$(SUFFIX) qtrtrs_LTN_single.$(SUFFIX)
CBLASOBJS = ctrtrs_UNU_single.$(SUFFIX) ctrtrs_UNN_single.$(SUFFIX) ctrtrs_UTU_single.$(SUFFIX) ctrtrs_UTN_single.$(SUFFIX) ctrtrs_URU_single.$(SUFFIX) ctrtrs_URN_single.$(SUFFIX) ctrtrs_UCU_single.$(SUFFIX) ctrtrs_UCN_single.$(SUFFIX) ctrtrs_LNU_single.$(SUFFIX) ctrtrs_LNN_single.$(SUFFIX) ctrtrs_LTU_single.$(SUFFIX) ctrtrs_LTN_single.$(SUFFIX) ctrtrs_LRU_single.$(SUFFIX) ctrtrs_LRN_single.$(SUFFIX) ctrtrs_LCU_single.$(SUFFIX) ctrtrs_LCN_single.$(SUFFIX)
ZBLASOBJS = ztrtrs_UNU_single.$(SUFFIX) ztrtrs_UNN_single.$(SUFFIX) ztrtrs_UTU_single.$(SUFFIX) ztrtrs_UTN_single.$(SUFFIX) ztrtrs_URU_single.$(SUFFIX) ztrtrs_URN_single.$(SUFFIX) ztrtrs_UCU_single.$(SUFFIX) ztrtrs_UCN_single.$(SUFFIX) ztrtrs_LNU_single.$(SUFFIX) ztrtrs_LNN_single.$(SUFFIX) ztrtrs_LTU_single.$(SUFFIX) ztrtrs_LTN_single.$(SUFFIX) ztrtrs_LRU_single.$(SUFFIX) ztrtrs_LRN_single.$(SUFFIX) ztrtrs_LCU_single.$(SUFFIX) ztrtrs_LCN_single.$(SUFFIX)
XBLASOBJS = xtrtrs_UNU_single.$(SUFFIX) xtrtrs_UNN_single.$(SUFFIX) xtrtrs_UTU_single.$(SUFFIX) xtrtrs_UTN_single.$(SUFFIX) xtrtrs_URU_single.$(SUFFIX) xtrtrs_URN_single.$(SUFFIX) xtrtrs_UCU_single.$(SUFFIX) xtrtrs_UCN_single.$(SUFFIX) xtrtrs_LNU_single.$(SUFFIX) xtrtrs_LNN_single.$(SUFFIX) xtrtrs_LTU_single.$(SUFFIX) xtrtrs_LTN_single.$(SUFFIX) xtrtrs_LRU_single.$(SUFFIX) xtrtrs_LRN_single.$(SUFFIX) xtrtrs_LCU_single.$(SUFFIX) xtrtrs_LCN_single.$(SUFFIX)

ifdef SMP
SBLASOBJS += strtrs_UNU_parallel.$(SUFFIX) strtrs_UNN_parallel.$(SUFFIX) strtrs_UTU_parallel.$(SUFFIX) strtrs_UTN_parallel.$(SUFFIX) strtrs_LNU_parallel.$(SUFFIX) strtrs_LNN_parallel.$(SUFFIX) strtrs_LTU_parallel.$(SUFFIX) strtrs_LTN_parallel.$(SUFFIX)
DBLASOBJS += dtrtrs_UNU_parallel.$(SUFFIX) dtrtrs_UNN_parallel.$(SUFFIX) dtrtrs_UTU_parallel.$(SUFFIX) dtrtrs_UTN_parallel.$(SUFFIX) dtrtrs_LNU_parallel.$(SUFFIX) dtrtrs_LNN_parallel.$(SUFFIX) dtrtrs_LTU_parallel.$(SUFFIX) dtrtrs_LTN_parallel.$(SUFFIX)
QBLASOBJS += qtrtrs_UNU_parallel.$(SUFFIX) qtrtrs_UNN_parallel.$(SUFFIX) qtrtrs_UTU_parallel.$(SUFFIX) qtrtrs_UTN_parallel.$(SUFFIX) qtrtrs_LNU_parallel.$(SUFFIX) qtrtrs_LNN_parallel.$(SUFFIX) qtrtrs_LTU_parallel.$(SUFFIX) qtrtrs_LTN_parallel.$(SUFFIX)
CBLASOBJS += ctrtrs_UNU_parallel.$(SUFFIX) ctrtrs_UNN_parallel.$(SUFFIX) ctrtrs_UTU_parallel.$(SUFFIX) ctrtrs_UTN_parallel.$(SUFFIX) ctrtrs_URU_parallel.$(SUFFIX) ctrtrs_URN_parallel.$(SUFFIX) ctrtrs_UCU_parallel.$(SUFFIX) ctrtrs_UCN_parallel.$(SUFFIX) ctrtrs_LNU_parallel.$(SUFFIX) ctrtrs_LNN_parallel.$(SUFFIX) ctrtrs_LTU_parallel.$(SUFFIX) ctrtrs_LTN_parallel.$(SUFFIX) ctrtrs_LRU_parallel.$(SUFFIX) ctrtrs_LRN_parallel.$(SUFFIX) ctrtrs_LCU_parallel.$(SUFFIX) ctrtrs_LCN_parallel.$(SUFFIX)
ZBLASOBJS += ztrtrs_UNU_parallel.$(SUFFIX) ztrtrs_UNN_parallel.$(SUFFIX) ztrtrs_UTU_parallel.$(SUFFIX) ztrtrs_UTN_parallel.$(SUFFIX) ztrtrs_URU_parallel.$(SUFFIX) ztrtrs_URN_parallel.$(SUFFIX) ztrtrs_UCU_parallel.$(SUFFIX) ztrtrs_UCN_parallel.$(SUFFIX) ztrtrs_LNU_parallel.$(SUFFIX) ztrtrs_LNN_parallel.$(SUFFIX) ztrtrs_LTU_parallel.$(SUFFIX) ztrtrs_LTN_parallel.$(SUFFIX) ztrtrs_LRU_parallel.$(SUFFIX) ztrtrs_LRN_parallel.$(SUFFIX) ztrtrs_LCU_parallel.$(SUFFIX) ztrtrs_LCN_parallel.$(SUFFIX)
XBLASOBJS += xtrtrs_UNU_parallel.$(SUFFIX) xtrtrs_UNN_parallel.$(SUFFIX) xtrtrs_UTU_parallel.$(SUFFIX) xtrtrs_UTN_parallel.$(SUFFIX) xtrtrs_URU_parallel.$(SUFFIX) xtrtrs_URN_parallel.$(SUFFIX) xtrtrs_UCU_parallel.$(SUFFIX) xtrtrs_UCN_parallel.$(SUFFIX) xtrtrs_LNU_parallel.$(SUFFIX) xtrtrs_LNN_parallel.$(SUFFIX) xtrtrs_LTU_parallel.$(SUFFIX) xtrtrs_LTN_parallel.$(SUFFIX) xtrtrs_LRU_parallel.$(SUFFIX) xtrtrs_LRN_parallel.$(SUFFIX) xtrtrs_LCU_parallel.$(SUFFIX) xtrtrs_LCN_parallel.$(SUFFIX)
endif

strtrs_UNU_single.$(SUFFIX) : trtrs_single.c
	$(CC) -c $(CFLAGS) -UCOMPLEX -UDOUBLE -UUPLO -UTRANS -UDIAG $< -o $(@F)

strtrs_UNN_single.$(SUFFIX) : trtrs_single.c
	$(CC) -c $(CFLAGS) -UCOMPLEX -UDOUBLE -UUPLO -UTRANS -DDIAG $< -o $(@F)

strtrs_UTU_single.$(SUFFIX) : trtrs_single.c
	$(CC) -c $(CFLAGS) -UCOMPLEX -UDOUBLE -UUPLO -DTRANS -UDIAG $< -o $(@F)

strtrs_UTN_single.$(SUFFIX) : trtrs_single.c
	$(CC) -c $(CFLAGS) -UCOMPLEX -UDOUBLE -UUPLO -DTRANS -DDIAG $< -o $(@F)

strtrs_LNU_single.$(SUFFIX) : trtrs_single.c
	$(CC) -c $(CFLAGS) -UCOMPLEX -UDOUBLE -DUPLO -UTRANS -UDIAG $< -o $(@F)

strtrs_LNN_single.$(SUFFIX) : trtrs_single.c
	$(CC) -c $(CFLAGS) -UCOMPLEX -UDOUBLE -DUPLO -UTRANS -DDIAG $< -o $(@F)

strtrs_LTU_single.$(SUFFIX) : trtrs_single.c
	$(CC) -c $(CFLAGS) -UCOMPLEX -UDOUBLE -DUPLO -DTRANS -UDIAG $< -o $(@F)

strtrs_LTN_single.$(SUFFIX) : trtrs_single.c
	$(CC) -c $(CFLAGS) -UCOMPLEX -UDOUBLE -DUPLO -DTRANS -DDIAG $< -o $(@F)

strtrs_UNU_parallel.$(SUFFIX) : trtrs_parallel.c
	$(CC) -c $(CFLAGS) -UCOMPLEX -UDOUBLE -UUPLO -UTRANS -UDIAG $< -o $(@F)

strtrs_UNN_parallel.$(SUFFIX) : trtrs_parallel.c
	$(CC) -c $(CFLAGS) -UCOMPLEX -UDOUBLE -UUPLO -UTRANS -DDIAG $< -o $(@F)

strtrs_UTU_parallel.$(SUFFIX) : trtrs_parallel.c
	$(CC) -c $(CFLAGS) -UCOMPLEX -UDOUBLE -UUPLO -DTRANS -UDIAG $< -o $(@F)

strtrs_UTN_parallel.$(SUFFIX) : trtrs_parallel.c
	$(CC) -c $(CFLAGS) -UCOMPLEX -UDOUBLE -UUPLO -DTRANS -DDIAG $< -o $(@F)

strtrs_LNU_parallel.$(SUFFIX) : trtrs_parallel.c
	$(CC) -c $(CFLAGS) -UCOMPLEX -UDOUBLE -DUPLO -UTRANS -UDIAG $< -o $(@F)

strtrs_LNN_parallel.$(SUFFIX) : trtrs_parallel.c
	$(CC) -c $(CFLAGS) -UCOMPLEX -UDOUBLE -DUPLO -UTRANS -DDIAG $< -o $(@F)

strtrs_LTU_parallel.$(SUFFIX) : trtrs_parallel.c
	$(CC) -c $(CFLAGS) -UCOMPLEX -UDOUBLE -DUPLO -DTRANS -UDIAG $< -o $(@F)

strtrs_LTN_parallel.$(SUFFIX) : trtrs_parallel.c
	$(CC) -c $(CFLAGS) -UCOMPLEX -UDOUBLE -DUPLO -DTRANS -DDIAG $< -o $(@F)

dtrtrs_UNU_single.$(SUFFIX) : trtrs_single.c
	$(CC) -c $(CFLAGS) -UCOMPLEX -DDOUBLE -UUPLO -UTRANS -UDIAG $< -o $(@F)

dtrtrs_UNN_single.$(SUFFIX) : trtrs_single.c
	$(CC) -c $(CFLAGS) -UCOMPLEX -DDOUBLE -UUPLO -UTRANS -DDIAG $< -o $(@F)

dtrtrs_UTU_single.$(SUFFIX) : trtrs_single.c
	$(CC) -c $(CFLAGS) -UCOMPLEX -DDOUBLE -UUPLO -DTRANS -UDIAG $< -o $(@F)

dtrtrs_UTN_single.$(SUFFIX) : trtrs_single.c
	$(CC) -c $(CFLAGS) -UCOMPLEX -DDOUBLE -UUPLO -DTRANS -DDIAG $< -o $(@F)

dtrtrs_LNU_single.$(SUFFIX) : trtrs_single.c
	$(CC) -c $(CFLAGS) -UCOMPLEX -DDOUBLE -DUPLO -UTRANS -UDIAG $< -o $(@F)

dtrtrs_LNN_single.$(SUFFIX) : trtrs_single.c
	$(CC) -c $(CFLAGS) -UCOMPLEX -DDOUBLE -DUPLO -UTRANS -DDIAG $< -o $(@F)

dtrtrs_LTU_single.$(SUFFIX) : trtrs_single.c
	$(CC) -c $(CFLAGS) -UCOMPLEX -DDOUBLE -DUPLO -DTRANS -UDIAG $< -o $(@F)

dtrtrs_LTN_single.$(SUFFIX) : trtrs_single.c
	$(CC) -c $(CFLAGS) -UCOMPLEX -DDOUBLE -DUPLO -DTRANS -DDIAG $< -o $(@F)

dtrtrs_UNU_parallel.$(SUFFIX) : trtrs_parallel.c
	$(CC) -c $(CFLAGS) -UCOMPLEX -DDOUBLE -UUPLO -UTRANS -UDIAG $< -o $(@F)

dtrtrs_UNN_parallel.$(SUFFIX) : trtrs_parallel.c
	$(CC) -c $(CFLAGS) -UCOMPLEX -DDOUBLE -UUPLO -UTRANS -DDIAG $< -o $(@F)

dtrtrs_UTU_parallel.$(SUFFIX) : trtrs_parallel.c
	$(CC) -c $(CFLAGS) -UCOMPLEX -DDOUBLE -UUPLO -DTRANS -UDIAG $< -o $(@F)

dtrtrs_UTN_parallel.$(SUFFIX) : trtrs_parallel.c
	$(CC) -c $(CFLAGS) -UCOMPLEX -DDOUBLE -UUPLO -DTRANS -DDIAG $< -o $(@F)

dtrtrs_LNU_parallel.$(SUFFIX) : trtrs_parallel.c
	$(CC) -c $(CFLAGS) -UCOMPLEX -DDOUBLE -DUPLO -UTRANS -UDIAG $< -o $(@F)

dtrtrs_LNN_parallel.$(SUFFIX) : trtrs_parallel.c
	$(CC) -c $(CFLAGS) -UCOMPLEX -DDOUBLE -DUPLO -UTRANS -DDIAG $< -o $(@F)

dtrtrs_LTU_parallel.$(SUFFIX) : trtrs_parallel.c
	$(CC) -c $(CFLAGS) -UCOMPLEX -DDOUBLE -DUPLO -DTRANS -UDIAG $< -o $(@F)

dtrtrs_LTN_parallel.$(SUFFIX) : trtrs_parallel.c
	$(CC) -c $(CFLAGS) -UCOMPLEX -DDOUBLE -DUPLO -DTRANS -DDIAG $< -o $(@F)

qtrtrs_UNU_single.$(SUFFIX) : trtrs_single.c
	$(CC) -c $(CFLAGS) -UCOMPLEX -DXDOUBLE -UUPLO -UTRANS -UDIAG $< -o $(@F)

qtrtrs_UNN_single.$(SUFFIX) : trtrs_single.c
	$(CC) -c $(CFLAGS) -UCOMPLEX -DXDOUBLE -UUPLO -UTRANS -DDIAG $< -o $(@F)

qtrtrs_UTU_single.$(SUFFIX) : trtrs_single.c
	$(CC) -c $(CFLAGS) -UCOMPLEX -DXDOUBLE -UUPLO -DTRANS -UDIAG $< -o $(@F)

qtrtrs_UTN_single.$(SUFFIX) : trtrs_single.c
	$(CC) -c $(CFLAGS) -UCOMPLEX -DXDOUBLE -UUPLO -DTRANS -DDIAG $< -o $(@F)

qtrtrs_LNU_single.$(SUFFIX) : trtrs_single.c
	$(CC) -c $(CFLAGS) -UCOMPLEX -DXDOUBLE -DUPLO -UTRANS -UDIAG $< -o $(@F)

qtrtrs_LNN_single.$(SUFFIX) : trtrs_single.c
	$(CC) -c $(CFLAGS) -UCOMPLEX -DXDOUBLE -DUPLO -UTRANS -DDIAG $< -o $(@F)

qtrtrs_LTU_single.$(SUFFIX) : trtrs_single.c
	$(CC) -c $(CFLAGS) -UCOMPLEX -DXDOUBLE -DUPLO -DTRANS -UDIAG $< -o $(@F)

qtrtrs_LTN_single.$(SUFFIX) : trtrs_single.c
	$(CC) -c $(CFLAGS) -UCOMPLEX -DXDOUBLE -DUPLO -DTRANS -DDIAG $< -o $(@F)

qtrtrs_UNU_parallel.$(SUFFIX) : trtrs_parallel.c
	$(CC) -c $(CFLAGS) -UCOMPLEX -DXDOUBLE -UUPLO -UTRANS -UDIAG $< -o $(@F)

qtrtrs_UNN_parallel.$(SUFFIX) : trtrs_parallel.c
	$(CC) -c $(CFLAGS) -UCOMPLEX -DXDOUBLE -UUPLO -UTRANS -DDIAG $< -o $(@F)

qtrtrs_UTU_parallel.$(SUFFIX) : trtrs_parallel.c
	$(CC) -c $(CFLAGS) -UCOMPLEX -DXDOUBLE -UUPLO -DTRANS -UDIAG $< -o $(@F)

qtrtrs_UTN_parallel.$(SUFFIX) : trtrs_parallel.c
	$(CC) -c $(CFLAGS) -UCOMPLEX -DXDOUBLE -UUPLO -DTRANS -DDIAG $< -o $(@F)

qtrtrs_LNU_parallel.$(SUFFIX) : trtrs_parallel.c
	$(CC) -c $(CFLAGS) -UCOMPLEX -DXDOUBLE -DUPLO -UTRANS -UDIAG $< -o $(@F)

qtrtrs_LNN_parallel.$(SUFFIX) : trtrs_parallel.c
	$(CC) -c $(CFLAGS) -UCOMPLEX -DXDOUBLE -DUPLO -UTRANS -DDIAG $< -o $(@F)

qtrtrs_LTU_parallel.$(SUFFIX) : trtrs_parallel.c
	$(CC) -c $(CFLAGS) -UCOMPLEX -DXDOUBLE -DUPLO -DTRANS -UDIAG $< -o $(@F)

qtrtrs_LTN_parallel.$(SUFFIX) : trtrs_parallel.c
	$(CC) -c $(CFLAGS) -UCOMPLEX -DXDOUBLE -DUPLO -DTRANS -DDIAG $< -o $(@F)

ctrtrs_UNU_single.$(SUFFIX) : ztrtrs_single.c
	$(CC) -c $(CFLAGS) -DCOMPLEX -UDOUBLE -UUPLO -DTRANS=1 -UDIAG $< -o $(@F)

ctrtrs_UNN_single.$(SUFFIX) : ztrtrs_single.c
	$(CC) -c $(CFLAGS) -DCOMPLEX -UDOUBLE -UUPLO -DTRANS=1 -DDIAG $< -o $(@F)

ctrtrs_UTU_single.$(SUFFIX) : ztrtrs_single.c
	$(CC) -c $(CFLAGS) -DCOMPLEX -UDOUBLE -UUPLO -DTRANS=2 -UDIAG $< -o $(@F)

ctrtrs_UTN_single.$(SUFFIX) : ztrtrs_single.c
	$(CC) -c $(CFLAGS) -DCOMPLEX -UDOUBLE -UUPLO -DTRANS=2 -DDIAG $< -o $(@F)

ctrtrs_URU_single.$(SUFFIX) : ztrtrs_single.c
	$(CC) -c $(CFLAGS) -DCOMPLEX -UDOUBLE -UUPLO -DTRANS=3 -UDIAG $< -o $(@F)

ctrtrs_URN_single.$(SUFFIX) : ztrtrs_single.c
	$(CC) -c $(CFLAGS) -DCOMPLEX -UDOUBLE -UUPLO -DTRANS=3 -DDIAG $< -o $(@F)

ctrtrs_UCU_single.$(SUFFIX) : ztrtrs_single.c
	$(CC) -c $(CFLAGS) -DCOMPLEX -UDOUBLE -UUPLO -DTRANS=4 -UDIAG $< -o $(@F)

ctrtrs_UCN_single.$(SUFFIX) : ztrtrs_single.c
	$(CC) -c $(CFLAGS) -DCOMPLEX -UDOUBLE -UUPLO -DTRANS=4 -DDIAG $< -o $(@F)

ctrtrs_LNU_single.$(SUFFIX) : ztrtrs_single.c
	$(CC) -c $(CFLAGS) -DCOMPLEX -UDOUBLE -DUPLO -DTRANS=1 -UDIAG $< -o $(@F)

ctrtrs_LNN_single.$(SUFFIX) : ztrtrs_single.c
	$(CC) -c $(CFLAGS) -DCOMPLEX -UDOUBLE -DUPLO -DTRANS=1 -DDIAG $< -o $(@F)

ctrtrs_LTU_single.$(SUFFIX) : ztrtrs_single.c
	$(CC) -c $(CFLAGS) -DCOMPLEX -UDOUBLE -DUPLO -DTRANS=2 -UDIAG $< -o $(@F)

ctrtrs_LTN_single.$(SUFFIX) : ztrtrs_single.c
	$(CC) -c $(CFLAGS) -DCOMPLEX -UDOUBLE -DUPLO -DTRANS=2 -DDIAG $< -o $(@F)

ctrtrs_LRU_single.$(SUFFIX) : ztrtrs_single.c
	$(CC) -c $(CFLAGS) -DCOMPLEX -UDOUBLE -DUPLO -DTRANS=3 -UDIAG $< -o $(@F)

ctrtrs_LRN_single.$(SUFFIX) : ztrtrs_single.c
	$(CC) -c $(CFLAGS) -DCOMPLEX -UDOUBLE -DUPLO -DTRANS=3 -DDIAG $< -o $(@F)

ctrtrs_LCU_single.$(SUFFIX) : ztrtrs_single.c

=== debian/changelog ===
openblas (0.3.9+ds-1+rpi1) bullseye-staging; urgency=medium

  [changes brought forward from 0.2.15-1+rpi1 by Peter Michael Green <plugwash@raspbian.org> at Fri, 11 Mar 2016 23:39:32 +0000]
  * Disable arm-gcc-flags.patch which was enforcing gcc flags that are wrong
    for raspbian.

 -- Raspbian forward porter <root@raspbian.org>  Thu, 26 Mar 2020 03:48:16 +0000

openblas (0.3.9+ds-1) unstable; urgency=medium

  * New upstream version 0.3.9+ds
  * d/copyright: reflect upstream changes
  * Drop link-tests-openmp.patch.
    Replace it by adding -fopenmp to FCOMMON_OPT at the relevant places in
    debian/rules.

 -- Sébastien Villemot <sebastien@debian.org>  Fri, 20 Mar 2020 14:40:43 +0100

=== debian/rules ===
#!/usr/bin/make -f
include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/pkg-info.mk
SOVER := 0
SRCS := $(filter-out debian $(FLAVORS), $(wildcard ./*))

MAKE_OPTIONS := NO_LAPACKE=1 NO_AFFINITY=1 NO_WARMUP=1 CFLAGS="$(CPPFLAGS) $(CFLAGS)" FFLAGS="$(FFLAGS)"

# Avoid having -O2 automatically added (especially for DEB_BUILD_OPTIONS=noopt)
MAKE_OPTIONS += COMMON_OPT=

# Build generic package with hardcoded max number of threads of 64
GENERIC_OPTIONS := NUM_THREADS=64

# Architectures with dynamic arch selection
# TARGET=GENERIC is needed to avoid FTBFS when CPU detection fails (see #923607)
ENABLE_DYNAMIC_ARCHS := amd64 arm64 i386 kfreebsd-amd64 kfreebsd-i386 ppc64el
ifneq (,$(findstring $(DEB_HOST_ARCH),$(ENABLE_DYNAMIC_ARCHS)))
	GENERIC_OPTIONS += DYNAMIC_ARCH=1 DYNAMIC_OLDER=1 TARGET=GENERIC
endif

# For other archs, there is no dynamic arch selection. To avoid selecting a
# target based on the buildd hardware, we enforce a generic-enough target.

# We cannot use the ARMv7 profile on armhf, because it requires a 32-register FP unit.
# See kernel/arm/KERNEL.ARMv7: it loads some *_vfpv3.S files, which use 32 registers.
# Also, it FTBFS if GCC flag -mvfpv3 is removed (see arm-gcc-flags.patch), because GCC
# refuses asm files with 32 FP registers in that case.
# Issue discussed in https://github.com/xianyi/OpenBLAS/issues/388
# See also debian/patches/arm-gcc-flags.patch which is related.
TARGET_OPTION_armhf     = TARGET=ARMV6
# We do not use DYNAMIC_ARCH selection on powerpc because it only works for
# POWER6 and above
TARGET_OPTION_powerpc   = TARGET=PPCG4
TARGET_OPTION_mips64el  = TARGET=SICORTEX
# We do not use DYNAMIC_ARCH selection on ppc64 because it fails to build.
# See https://buildd.debian.org/status/fetch.php?pkg=openblas&arch=ppc64&ver=0.3.6%2Bds-1&stamp=1562602383&raw=0
# POWER6 is the most generic arch that compiles on ppc64
TARGET_OPTION_ppc64     = TARGET=POWER6
TARGET_OPTION_sparc64   = TARGET=SPARC
TARGET_OPTION_s390x     = TARGET=ZARCH_GENERIC
GENERIC_OPTIONS += $(TARGET_OPTION_$(DEB_HOST_ARCH))


ifeq (,$(filter custom,$(DEB_BUILD_OPTIONS)))
	# Generic package
	MAKE_OPTIONS += $(GENERIC_OPTIONS)
else
	# Custom package: leave the arch detection to OpenBLAS, and optimize for the current CPU
	export DEB_CFLAGS_MAINT_APPEND := -march=native -mtune=native
	export DEB_FFLAGS_MAINT_APPEND := -march=native -mtune=native
endif

# Flavors: 64-bit array indexing is invalid for 32-bit machines.
ifeq (64,$(DEB_HOST_ARCH_BITS))
	FLAVORS = $(SOVER)-pthread $(SOVER)-openmp $(SOVER)-serial 64-$(SOVER)-pthread 64-$(SOVER)-openmp 64-$(SOVER)-serial
else
	FLAVORS = $(SOVER)-pthread $(SOVER)-openmp $(SOVER)-serial
endif
# FLAVORS =  # XXX: Define your target configurations here if you are going to build customized packages
FLAGS_0-pthread    := USE_THREAD=1 USE_OPENMP=0 INTERFACE64=0 LIBPREFIX=libopenblas   FCOMMON_OPT=-frecursive
FLAGS_0-openmp     := USE_THREAD=1 USE_OPENMP=1 INTERFACE64=0 LIBPREFIX=libopenblas   FCOMMON_OPT='-frecursive -fopenmp'
FLAGS_0-serial     := USE_THREAD=0 USE_OPENMP=0 INTERFACE64=0 LIBPREFIX=libopenblas   FCOMMON_OPT=-frecursive
FLAGS_64-0-pthread := USE_THREAD=1 USE_OPENMP=0 INTERFACE64=1 LIBPREFIX=libopenblas64 FCOMMON_OPT='-frecursive -fdefault-integer-8'
FLAGS_64-0-openmp  := USE_THREAD=1 USE_OPENMP=1 INTERFACE64=1 LIBPREFIX=libopenblas64 FCOMMON_OPT='-frecursive -fopenmp -fdefault-integer-8'
FLAGS_64-0-serial  := USE_THREAD=0 USE_OPENMP=0 INTERFACE64=1 LIBPREFIX=libopenblas64 FCOMMON_OPT='-frecursive -fdefault-integer-8'

# Priority values in the Update-Alternatives mechanism.
# O,P,S stands for openmp, pthread, serial respectively
UAPRI_O = 95
UAPRI_P = 100
UAPRI_S = 90


%:
	dh $@

override_dh_auto_configure: $(addprefix config_, $(FLAVORS))
	:

config_%:
	# shared object packages
	mkdir $*; cp -r $(SRCS) $*/;
	for i in install postinst prerm shlibs; do \
		if test -z "$$(echo $* | grep 64)"; then \
			cp debian/libopenblas$(SOVER)-XXX.$$i debian/libopenblas$*.$$i; \
		else \
			cp debian/libopenblas64-$(SOVER)-XXX.$$i debian/libopenblas$*.$$i; \
		fi; \
		sed -i -e "s/@DEB_HOST_MULTIARCH@/$(DEB_HOST_MULTIARCH)/g" \
			-e "s/@SUBDIR@/openblas$(subst $(SOVER)-,-,$(subst -$(SOVER)-,-,$*))/g" \
			-e "s/@FLAVOR@/$*/g" \
			debian/libopenblas$*.$$i; \
		if test -n "$$(echo $* | grep pthread)"; then \
			sed -i -e "s/@OPENBLAS_PRI@/$(UAPRI_P)/g" debian/libopenblas$*.$$i; \
		elif test -n "$$(echo $* | grep openmp)"; then \
			sed -i -e "s/@OPENBLAS_PRI@/$(UAPRI_O)/g" debian/libopenblas$*.$$i; \
		else \
			sed -i -e "s/@OPENBLAS_PRI@/$(UAPRI_S)/g" debian/libopenblas$*.$$i; \
		fi; \
	done;
	# devel packages
	for i in install links postinst prerm dirs; do \
		if test -z "$$(echo $* | grep 64)"; then \
			cp debian/libopenblas-XXX-dev.$$i debian/libopenblas$(subst $(SOVER)-,-,$(subst -$(SOVER)-,-,$*))-dev.$$i; \
		else \
			cp debian/libopenblas64-XXX-dev.$$i debian/libopenblas$(subst $(SOVER)-,-,$(subst -$(SOVER)-,-,$*))-dev.$$i; \
		fi; \
		sed -i -e "s/@DEB_HOST_MULTIARCH@/$(DEB_HOST_MULTIARCH)/g" \
			-e "s/@SUBDIR@/openblas$(subst $(SOVER)-,-,$(subst -$(SOVER)-,-,$*))/g" \
			-e "s/@FLAVOR@/$*/g" \
			debian/libopenblas$(subst $(SOVER)-,-,$(subst -$(SOVER)-,-,$*))-dev.$$i; \
		if test -n "$$(echo $* | grep pthread)"; then \
			sed -i -e "s/@OPENBLAS_PRI@/$(UAPRI_P)/g" debian/libopenblas$(subst $(SOVER)-,-,$(subst -$(SOVER)-,-,$*))-dev.$$i; \
		elif test -n "$$(echo $* | grep openmp)"; then \
			sed -i -e "s/@OPENBLAS_PRI@/$(UAPRI_O)/g" debian/libopenblas$(subst $(SOVER)-,-,$(subst -$(SOVER)-,-,$*))-dev.$$i; \
		else \
			sed -i -e "s/@OPENBLAS_PRI@/$(UAPRI_S)/g" debian/libopenblas$(subst $(SOVER)-,-,$(subst -$(SOVER)-,-,$*))-dev.$$i; \
		fi; \
	done;

override_dh_auto_build: 
	for target in $(addprefix build_, $(FLAVORS)); do \
		$(MAKE) -f debian/rules $$target || exit 1; done

build_0-pthread:
	$(MAKE) -C 0-pthread libs netlib shared $(MAKE_OPTIONS) $(FLAGS_0-pthread)
	$(MAKE) -C 0-pthread/interface shared-blas-lapack $(MAKE_OPTIONS) $(FLAGS_0-pthread)
build_64-0-pthread:
	$(MAKE) -C 64-0-pthread libs netlib shared $(MAKE_OPTIONS) $(FLAGS_64-0-pthread)
	$(MAKE) -C 64-0-pthread/interface shared-blas64-lapack64 $(MAKE_OPTIONS) $(FLAGS_64-0-pthread)
build_0-openmp:
	$(MAKE) -C 0-openmp libs netlib shared $(MAKE_OPTIONS) $(FLAGS_0-openmp)
	$(MAKE) -C 0-openmp/interface shared-blas-lapack $(MAKE_OPTIONS) $(FLAGS_0-openmp)
build_64-0-openmp:
	$(MAKE) -C 64-0-openmp libs netlib shared $(MAKE_OPTIONS) $(FLAGS_64-0-openmp)
	$(MAKE) -C 64-0-openmp/interface shared-blas64-lapack64 $(MAKE_OPTIONS) $(FLAGS_64-0-openmp)
build_0-serial:
	$(MAKE) -C 0-serial libs netlib shared $(MAKE_OPTIONS) $(FLAGS_0-serial)
	$(MAKE) -C 0-serial/interface shared-blas-lapack $(MAKE_OPTIONS) $(FLAGS_0-serial)
build_64-0-serial:
	$(MAKE) -C 64-0-serial libs netlib shared $(MAKE_OPTIONS) $(FLAGS_64-0-serial)
	$(MAKE) -C 64-0-serial/interface shared-blas64-lapack64 $(MAKE_OPTIONS) $(FLAGS_64-0-serial)
# XXX: why doesn't this work??
#build_%:
#   $(MAKE) -C $* $(MAKE_OPTIONS) $(FLAGS_$*)
#   $(MAKE) -C $*/interface $(MAKE_OPTIONS) $(FLAGS_$*)

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	for target in $(addprefix test_, $(FLAVORS)); do \
		$(MAKE) -f debian/rules $$target || exit 1; done
endif

test_0-pthread:
	$(MAKE) -C 0-pthread tests $(MAKE_OPTIONS) $(FLAGS_0-pthread)
test_64-0-pthread:
	$(MAKE) -C 64-0-pthread tests $(MAKE_OPTIONS) $(FLAGS_64-0-pthread)
test_0-openmp:
	$(MAKE) -C 0-openmp tests $(MAKE_OPTIONS) $(FLAGS_0-openmp)
test_64-0-openmp:
	$(MAKE) -C 64-0-openmp tests $(MAKE_OPTIONS) $(FLAGS_64-0-openmp)
test_0-serial:
	$(MAKE) -C 0-serial tests $(MAKE_OPTIONS) $(FLAGS_0-serial)
test_64-0-serial:
	$(MAKE) -C 64-0-serial tests $(MAKE_OPTIONS) $(FLAGS_64-0-serial)
# XXX: why cannot this work?
#test_%:
#	$(MAKE) -C $* test $(MAKE_OPTIONS) $(FLAGS_$(*))

override_dh_auto_install:
	for target in $(addprefix install_, $(FLAVORS)); do \
		$(MAKE) -f debian/rules $$target || exit 1; done

## openblas 0.3.10+ds

=== debian/changelog ===
openblas (0.3.10+ds-3ubuntu1) groovy; urgency=medium

  * Enable dynamic arch support on s390x. LP: #1893653

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 17 Sep 2020 15:37:04 +0100

openblas (0.3.10+ds-3) unstable; urgency=medium

  [ Mo Zhou ]
  * Fix confusion bug in the libblas.so.3->libopenblas.so.0 linkage.
    We added -Wl,-rpath,'$ORIGIN' in the RPATH attribute of the libblas.so.3
    shared objects. Without this fix, `ldd openblas-serial/libblas.so.3`
    will resolve the libopenblas.so.0 dependency to the symbol link
    controlled by the alternatives mechanism, e.g. libopenblas.so.0 ->
    openblas-pthread/libopenblas.so.0, which breaks the literal meaning
    of the user's libblas.so.3 <--provies-- openblas-serial configuration.
  * Remove the unnecessary dh_shlibdeps overrides.
  * Remove ${shlibs:Depends} dependency from -dev and -meta packages.
  * Fix symbol mangling for libjulia-openblas64.
  * B-D on lapack (>= 3.9.0-3) for BLAS64 version of deprecated routines.

  [ Sébastien Villemot ]
  * d/rules: ensure that shared-library flavoured packages do not depend on
    libopenblas{64-,}0 metapackages. A circular dependency:
     libopenblas0 → libopenblas0-{pthread,openmp,serial} → libopenblas0
    was introduced in 0.3.10+ds-2, since lib{blas,lapack}.so.3 is (again)
    dynamically linked against libopenblas0. We break the loop manually at the
    dpkg-shlibdeps level. (Closes: #966607)

 -- Mo Zhou <lumin@debian.org>  Sat, 01 Aug 2020 23:25:44 +0800

openblas (0.3.10+ds-2) unstable; urgency=medium

  * lib{blas,lapack}.so.3 are again dynamically linked against libopenblas.so.0.
    This restores the pre-multi-flavour behaviour.
    Incidentally, this brings back the possibility of checking at runtime for
    the presence of openblas_get_config symbol. (Closes: #960728)
  * fix-dynamic-arch-gemm-crashes.patch: new patch (Closes: #966175)
  * Add debian/upstream/metadata

 -- Sébastien Villemot <sebastien@debian.org>  Wed, 29 Jul 2020 14:51:22 +0200

openblas (0.3.10+ds-1) unstable; urgency=medium

  [ Mo Zhou ]
  * New upstream version 0.3.10+ds
  * Refresh existing patches.

  [ Sébastien Villemot ]
  * d/copyright: reflect upstream changes

 -- Mo Zhou <lumin@debian.org>  Tue, 07 Jul 2020 19:50:08 +0800

openblas (0.3.9+ds-3) unstable; urgency=medium

  [ Sébastien Villemot ]
  * Remove B-D on dh-exec, no longer needed since debhelper 13
  * On Ubuntu, strip -Wl,-Bsymbolic-functions from LDFLAGS (Closes: #961725)
  * Update Homepage to https://www.openblas.net

  [ Mo Zhou ]
  * Let libopenblas64-julia Conflict & Replace libjulia1 (<< 1.4.1+dfsg-1)
    (Closes: #963223)
  * Upload to unstable.

 -- Mo Zhou <lumin@debian.org>  Thu, 25 Jun 2020 17:39:59 +0800

openblas (0.3.9+ds-2) experimental; urgency=medium

  * Build the custom version of OpenBLAS for Julia.
  * Update my mail address in Uploaders.
  * Bump debhelper compat level to 13 (no change).

 -- Mo Zhou <lumin@debian.org>  Thu, 14 May 2020 19:06:33 +0800

=== debian/control ===
Source: openblas
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Sébastien Villemot <sebastien@debian.org>,
           Mo Zhou <lumin@debian.org>
Section: devel
Priority: optional
Build-Depends: debhelper-compat (= 13),
               gfortran,
               liblapack-dev (>= 3.9.0-3~),
               liblapack64-dev (>= 3.9.0-3~) [amd64 arm64 ppc64el ppc64 kfreebsd-amd64 mips64el sparc64 s390x],
Standards-Version: 4.5.0
Vcs-Browser: https://salsa.debian.org/science-team/openblas
Vcs-Git: https://salsa.debian.org/science-team/openblas.git
Homepage: https://www.openblas.net/
Rules-Requires-Root: no

# 32-bit indexing version

Package: libopenblas0
Architecture: amd64 arm64 armhf i386 powerpc ppc64el ppc64 kfreebsd-i386 kfreebsd-amd64 mips64el sparc64 s390x
Multi-Arch: same
Section: metapackages
Depends: ${misc:Depends},
         libopenblas0-pthread | libopenblas0-openmp | libopenblas0-serial,
Breaks: libblas3 (<< 3.7.1-2~),
        liblapack3 (<< 3.7.1-2~),
        libatlas3-base (<< 3.10.3-4~),
        libopenblas-dev (<< 0.2.20+ds-3~)
Description: Optimized BLAS (linear algebra) library (meta)
 OpenBLAS is an optimized BLAS library based on GotoBLAS2 1.13 BSD version.
 .
 Unlike Atlas, OpenBLAS provides a multiple architecture library.
 .
 All kernel will be included in the library and dynamically switched to the
 best architecture at run time (only on amd64, arm64, i386 and ppc64el).
 .
 For more information on how to rebuild locally OpenBLAS, see the section:
 "Building Optimized OpenBLAS Packages on your ARCH" in README.Debian

Package: libopenblas0-pthread
Architecture: amd64 arm64 armhf i386 powerpc ppc64el ppc64 kfreebsd-i386 kfreebsd-amd64 mips64el sparc64 s390x
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Breaks: libblas3 (<< 3.7.1-2~),
        liblapack3 (<< 3.7.1-2~),
        libatlas3-base (<< 3.10.3-4~),
        libopenblas-dev (<< 0.2.20+ds-3~)
Provides: libblas.so.3,
          liblapack.so.3
Description: Optimized BLAS (linear algebra) library (shared lib, pthread)
 OpenBLAS is an optimized BLAS library based on GotoBLAS2 1.13 BSD version.
 .
 Unlike Atlas, OpenBLAS provides a multiple architecture library.
 .
 All kernel will be included in the library and dynamically switched to the
 best architecture at run time (only on amd64, arm64, i386 and ppc64el).
 .
 For more information on how to rebuild locally OpenBLAS, see the section:
 "Building Optimized OpenBLAS Packages on your ARCH" in README.Debian
 .
 Configuration: USE_THREAD=1 USE_OPENMP=0 INTERFACE64=0

Package: libopenblas0-openmp
Architecture: amd64 arm64 armhf i386 powerpc ppc64el ppc64 kfreebsd-i386 kfreebsd-amd64 mips64el sparc64 s390x
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Breaks: libblas3 (<< 3.7.1-2~),
        liblapack3 (<< 3.7.1-2~),
        libatlas3-base (<< 3.10.3-4~),
        libopenblas-dev (<< 0.2.20+ds-3~)
Provides: libblas.so.3,
          liblapack.so.3
Description: Optimized BLAS (linear algebra) library (shared lib, openmp)
 OpenBLAS is an optimized BLAS library based on GotoBLAS2 1.13 BSD version.
 .
 Unlike Atlas, OpenBLAS provides a multiple architecture library.
 .
 All kernel will be included in the library and dynamically switched to the
 best architecture at run time (only on amd64, arm64, i386 and ppc64el).
 .
 For more information on how to rebuild locally OpenBLAS, see the section:
 "Building Optimized OpenBLAS Packages on your ARCH" in README.Debian
 .
 Configuration: USE_THREAD=1 USE_OPENMP=1 INTERFACE64=0

Package: libopenblas0-serial
Architecture: amd64 arm64 armhf i386 powerpc ppc64el ppc64 kfreebsd-i386 kfreebsd-amd64 mips64el sparc64 s390x
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Breaks: libblas3 (<< 3.7.1-2~),
        liblapack3 (<< 3.7.1-2~),
        libatlas3-base (<< 3.10.3-4~),
        libopenblas-dev (<< 0.2.20+ds-3~)
Provides: libblas.so.3,
          liblapack.so.3
Description: Optimized BLAS (linear algebra) library (shared lib, serial)
 OpenBLAS is an optimized BLAS library based on GotoBLAS2 1.13 BSD version.
 .
 Unlike Atlas, OpenBLAS provides a multiple architecture library.
 .
 All kernel will be included in the library and dynamically switched to the
 best architecture at run time (only on amd64, arm64, i386 and ppc64el).
 .
 For more information on how to rebuild locally OpenBLAS, see the section:
 "Building Optimized OpenBLAS Packages on your ARCH" in README.Debian
 .
 Configuration: USE_THREAD=0 USE_OPENMP=0 INTERFACE64=0

Package: libopenblas-base
Architecture: amd64 arm64 armhf i386 powerpc ppc64el ppc64 kfreebsd-i386 kfreebsd-amd64 mips64el sparc64 s390x
Multi-Arch: same
Section: oldlibs
Depends: ${misc:Depends},
         libopenblas0,
Breaks: libblas3 (<< 3.7.1-2~),
        liblapack3 (<< 3.7.1-2~),
        libatlas3-base (<< 3.10.3-4~),
        libopenblas-dev (<< 0.2.20+ds-3~)
Description: Optimized BLAS (linear algebra) library (transitional)
 OpenBLAS is an optimized BLAS library based on GotoBLAS2 1.13 BSD version.
 .
 Unlike Atlas, OpenBLAS provides a multiple architecture library.
 .
 All kernel will be included in the library and dynamically switched to the
 best architecture at run time (only on amd64, arm64, i386 and ppc64el).
 .
 For more information on how to rebuild locally OpenBLAS, see the section:
 "Building Optimized OpenBLAS Packages on your ARCH" in README.Debian
 .
 This is a transitional dummy package, which can be safely removed.

Package: libopenblas-dev
Architecture: amd64 arm64 armhf i386 powerpc ppc64el ppc64 kfreebsd-i386 kfreebsd-amd64 mips64el sparc64 s390x
Multi-Arch: same
Section: metapackages
Depends: libopenblas0 (= ${binary:Version}),
         ${misc:Depends},
         libopenblas-pthread-dev | libopenblas-openmp-dev | libopenblas-serial-dev,
Breaks: libblas-dev (<< 3.7.1-2~),
        liblapack-dev (<< 3.7.1-2~),
        libatlas-base-dev (<< 3.10.3-4~)
Description: Optimized BLAS (linear algebra) library (dev, meta)
 OpenBLAS is an optimized BLAS library based on GotoBLAS2 1.13 BSD version.
 .
 Unlike Atlas, OpenBLAS provides a multiple architecture library.
 .
 All kernel will be included in the library and dynamically switched to the
 best architecture at run time (only on amd64, arm64, i386 and ppc64el).
 .
 This package includes the static libraries and symbolic links
 needed for program development.

Package: libopenblas-pthread-dev
Architecture: amd64 arm64 armhf i386 powerpc ppc64el ppc64 kfreebsd-i386 kfreebsd-amd64 mips64el sparc64 s390x
Multi-Arch: same
Section: libdevel
Depends: libopenblas0-pthread (= ${binary:Version}),
         ${misc:Depends}
Breaks: libblas-dev (<< 3.7.1-2~),
        liblapack-dev (<< 3.7.1-2~),
        libatlas-base-dev (<< 3.10.3-4~)
Provides: libblas.so,
          liblapack.so
Description: Optimized BLAS (linear algebra) library (dev, pthread)
 OpenBLAS is an optimized BLAS library based on GotoBLAS2 1.13 BSD version.
 .
 Unlike Atlas, OpenBLAS provides a multiple architecture library.
 .
 All kernel will be included in the library and dynamically switched to the
 best architecture at run time (only on amd64, arm64, i386 and ppc64el).
 .
 This package includes the static libraries and symbolic links
 needed for program development.
 .
 Configuration: USE_THREAD=1 USE_OPENMP=0 INTERFACE64=0

Package: libopenblas-openmp-dev
Architecture: amd64 arm64 armhf i386 powerpc ppc64el ppc64 kfreebsd-i386 kfreebsd-amd64 mips64el sparc64 s390x
Multi-Arch: same
Section: libdevel
Depends: libopenblas0-openmp (= ${binary:Version}),
         ${misc:Depends}
Breaks: libblas-dev (<< 3.7.1-2~),
        liblapack-dev (<< 3.7.1-2~),
        libatlas-base-dev (<< 3.10.3-4~)
Provides: libblas.so,
          liblapack.so
Description: Optimized BLAS (linear algebra) library (dev, openmp)
 OpenBLAS is an optimized BLAS library based on GotoBLAS2 1.13 BSD version.
 .
 Unlike Atlas, OpenBLAS provides a multiple architecture library.
 .
 All kernel will be included in the library and dynamically switched to the
 best architecture at run time (only on amd64, arm64, i386 and ppc64el).
 .
 This package includes the static libraries and symbolic links
 needed for program development.
 .
 Configuration: USE_THREAD=1 USE_OPENMP=1 INTERFACE64=0

Package: libopenblas-serial-dev
Architecture: amd64 arm64 armhf i386 powerpc ppc64el ppc64 kfreebsd-i386 kfreebsd-amd64 mips64el sparc64 s390x
Multi-Arch: same
Section: libdevel
Depends: libopenblas0-serial (= ${binary:Version}),
         ${misc:Depends}
Breaks: libblas-dev (<< 3.7.1-2~),
        liblapack-dev (<< 3.7.1-2~),
        libatlas-base-dev (<< 3.10.3-4~)
Provides: libblas.so,
          liblapack.so
Description: Optimized BLAS (linear algebra) library (dev, serial)
 OpenBLAS is an optimized BLAS library based on GotoBLAS2 1.13 BSD version.
 .
 Unlike Atlas, OpenBLAS provides a multiple architecture library.
 .
 All kernel will be included in the library and dynamically switched to the
 best architecture at run time (only on amd64, arm64, i386 and ppc64el).
 .
 This package includes the static libraries and symbolic links
 needed for program development.
 .
 Configuration: USE_THREAD=0 USE_OPENMP=0 INTERFACE64=0

# 64-bit indexing version

Package: libopenblas64-0
Architecture: amd64 arm64 kfreebsd-amd64 ppc64 ppc64el mips64el sparc64 s390x
Multi-Arch: same
Section: metapackages
Depends: ${misc:Depends},
         libopenblas64-0-pthread | libopenblas64-0-openmp | libopenblas64-0-serial,
Description: Optimized BLAS (linear algebra) library (shared lib, 64bit, meta)
 OpenBLAS is an optimized BLAS library based on GotoBLAS2 1.13 BSD version.
 .
 Unlike Atlas, OpenBLAS provides a multiple architecture library.
 .
 All kernel will be included in the library and dynamically switched to the
 best architecture at run time (only on amd64, arm64, i386 and ppc64el).
 .
 For more information on how to rebuild locally OpenBLAS, see the section:
 "Building Optimized OpenBLAS Packages on your ARCH" in README.Debian
 .
 This metapackage provides a 64-bit indexing version.

Package: libopenblas64-0-pthread
Architecture: amd64 arm64 kfreebsd-amd64 ppc64 ppc64el mips64el sparc64 s390x
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Provides: libblas64.so.3,
          liblapack64.so.3
Description: Optimized BLAS (linear algebra) library (shared lib, 64bit, pthread)
 OpenBLAS is an optimized BLAS library based on GotoBLAS2 1.13 BSD version.
 .
 Unlike Atlas, OpenBLAS provides a multiple architecture library.
 .
 All kernel will be included in the library and dynamically switched to the
 best architecture at run time (only on amd64, arm64, i386 and ppc64el).
 .
 For more information on how to rebuild locally OpenBLAS, see the section:
 "Building Optimized OpenBLAS Packages on your ARCH" in README.Debian
 .
 Configuration: USE_THREAD=1 USE_OPENMP=0 INTERFACE64=1

Package: libopenblas64-0-openmp
Architecture: amd64 arm64 kfreebsd-amd64 ppc64 ppc64el mips64el sparc64 s390x
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Provides: libblas64.so.3,
          liblapack64.so.3
Description: Optimized BLAS (linear algebra) library (shared lib, 64bit, openmp)
 OpenBLAS is an optimized BLAS library based on GotoBLAS2 1.13 BSD version.
 .
 Unlike Atlas, OpenBLAS provides a multiple architecture library.
 .
 All kernel will be included in the library and dynamically switched to the
 best architecture at run time (only on amd64, arm64, i386 and ppc64el).
 .
 For more information on how to rebuild locally OpenBLAS, see the section:
 "Building Optimized OpenBLAS Packages on your ARCH" in README.Debian
 .
 Configuration: USE_THREAD=1 USE_OPENMP=1 INTERFACE64=1

Package: libopenblas64-0-serial
Architecture: amd64 arm64 kfreebsd-amd64 ppc64 ppc64el mips64el sparc64 s390x

=== debian/rules ===
--- 
+++ 
@@ -1,4 +1,8 @@
 #!/usr/bin/make -f
+
+# For Ubuntu, see #961725
+export DEB_LDFLAGS_MAINT_STRIP := "-Wl,-Bsymbolic-functions"
+
 include /usr/share/dpkg/buildflags.mk
 include /usr/share/dpkg/pkg-info.mk
 SOVER := 0
@@ -14,7 +18,7 @@
 
 # Architectures with dynamic arch selection
 # TARGET=GENERIC is needed to avoid FTBFS when CPU detection fails (see #923607)
-ENABLE_DYNAMIC_ARCHS := amd64 arm64 i386 kfreebsd-amd64 kfreebsd-i386 ppc64el
+ENABLE_DYNAMIC_ARCHS := amd64 arm64 i386 kfreebsd-amd64 kfreebsd-i386 ppc64el s390x
 ifneq (,$(findstring $(DEB_HOST_ARCH),$(ENABLE_DYNAMIC_ARCHS)))
 	GENERIC_OPTIONS += DYNAMIC_ARCH=1 DYNAMIC_OLDER=1 TARGET=GENERIC
 endif
@@ -64,6 +68,8 @@
 FLAGS_64-0-pthread := USE_THREAD=1 USE_OPENMP=0 INTERFACE64=1 LIBPREFIX=libopenblas64 FCOMMON_OPT='-frecursive -fdefault-integer-8'
 FLAGS_64-0-openmp  := USE_THREAD=1 USE_OPENMP=1 INTERFACE64=1 LIBPREFIX=libopenblas64 FCOMMON_OPT='-frecursive -fopenmp -fdefault-integer-8'
 FLAGS_64-0-serial  := USE_THREAD=0 USE_OPENMP=0 INTERFACE64=1 LIBPREFIX=libopenblas64 FCOMMON_OPT='-frecursive -fdefault-integer-8'
+FLAGS_julia        := USE_THREAD=1 USE_OPENMP=0 INTERFACE64=1 LIBPREFIX=libopenblas64_ FCOMMON_OPT='-frecursive -fdefault-integer-8' \
+	SYMBOLSUFFIX=64_ GEMM_MULTITHREADING_THRESHOLD=50 NO_AFFINITY=1
 
 # Priority values in the Update-Alternatives mechanism.
 # O,P,S stands for openmp, pthread, serial respectively
@@ -76,6 +82,12 @@
 	dh $@
 
 override_dh_auto_configure: $(addprefix config_, $(FLAVORS))
+ifneq (,$(filter $(DEB_HOST_ARCH), amd64 arm64 ppc64el))
+ifeq (,$(filter custom,$(DEB_BUILD_OPTIONS)))
+	# shared object package for Julia's custom use
+	mkdir julia; cp -r $(SRCS) julia/;
+endif
+endif
 	:
 
 config_%:
@@ -119,9 +131,15 @@
 		fi; \
 	done;
 
-override_dh_auto_build: 
+override_dh_auto_build:
 	for target in $(addprefix build_, $(FLAVORS)); do \
 		$(MAKE) -f debian/rules $$target || exit 1; done
+ifneq (,$(filter $(DEB_HOST_ARCH), amd64 arm64 ppc64el))
+ifeq (,$(filter custom,$(DEB_BUILD_OPTIONS)))
+	# shared object package for Julia's custom use
+	$(MAKE) -C julia libs netlib shared $(MAKE_OPTIONS) $(FLAGS_julia)
+endif
+endif
 
 build_0-pthread:
 	$(MAKE) -C 0-pthread libs netlib shared $(MAKE_OPTIONS) $(FLAGS_0-pthread)
@@ -150,24 +168,3 @@
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
 	for target in $(addprefix test_, $(FLAVORS)); do \
 		$(MAKE) -f debian/rules $$target || exit 1; done
-endif
-
-test_0-pthread:
-	$(MAKE) -C 0-pthread tests $(MAKE_OPTIONS) $(FLAGS_0-pthread)
-test_64-0-pthread:
-	$(MAKE) -C 64-0-pthread tests $(MAKE_OPTIONS) $(FLAGS_64-0-pthread)
-test_0-openmp:
-	$(MAKE) -C 0-openmp tests $(MAKE_OPTIONS) $(FLAGS_0-openmp)
-test_64-0-openmp:
-	$(MAKE) -C 64-0-openmp tests $(MAKE_OPTIONS) $(FLAGS_64-0-openmp)
-test_0-serial:
-	$(MAKE) -C 0-serial tests $(MAKE_OPTIONS) $(FLAGS_0-serial)
-test_64-0-serial:
-	$(MAKE) -C 64-0-serial tests $(MAKE_OPTIONS) $(FLAGS_64-0-serial)
-# XXX: why cannot this work?
-#test_%:
-#	$(MAKE) -C $* test $(MAKE_OPTIONS) $(FLAGS_$(*))
-
-override_dh_auto_install:
-	for target in $(addprefix install_, $(FLAVORS)); do \
-		$(MAKE) -f debian/rules $$target || exit 1; done

## openblas 0.3.13%2Bds

=== lapack/laswp/generic/Makefile ===
ifndef INCLUDED
TOPDIR = ../../..
include $(TOPDIR)/Makefile.system
endif

ifndef LASWP
LASWP	= ../generic/laswp_k.c
endif

ifndef ZLASWP
ZLASWP	= ../generic/zlaswp_k.c
endif

LASWP_DEPS  = ../generic/laswp_k_1.c ../generic/laswp_k_2.c \
	      ../generic/laswp_k_4.c ../generic/laswp_k_8.c

ZLASWP_DEPS = ../generic/zlaswp_k_1.c ../generic/zlaswp_k_2.c \
	      ../generic/zlaswp_k_4.c

include ../../../Makefile.tail

all:

../slaswp_plus.$(SUFFIX) : $(LASWP) $(LASWP_DEPS)
	$(CC) -c $(CFLAGS) -UDOUBLE -UMINUS $< -o ../$(@F)

../slaswp_minus.$(SUFFIX) : $(LASWP) $(LASWP_DEPS)
	$(CC) -c $(CFLAGS) -UDOUBLE -DMINUS $< -o ../$(@F)

../dlaswp_plus.$(SUFFIX) : $(LASWP) $(LASWP_DEPS)
	$(CC) -c $(CFLAGS) -DDOUBLE -UMINUS $< -o ../$(@F)

../dlaswp_minus.$(SUFFIX) : $(LASWP) $(LASWP_DEPS)
	$(CC) -c $(CFLAGS) -DDOUBLE -DMINUS $< -o ../$(@F)

../qlaswp_plus.$(SUFFIX) : $(LASWP) $(LASWP_DEPS)
	$(CC) -c $(CFLAGS) -DXDOUBLE -UMINUS $< -o ../$(@F)

../qlaswp_minus.$(SUFFIX) : $(LASWP) $(LASWP_DEPS)
	$(CC) -c $(CFLAGS) -DXDOUBLE -DMINUS $< -o ../$(@F)

../claswp_plus.$(SUFFIX) : $(ZLASWP) $(ZLASWP_DEPS)
	$(CC) -c $(CFLAGS) -UDOUBLE -UMINUS $< -o ../$(@F)

../claswp_minus.$(SUFFIX) : $(ZLASWP) $(ZLASWP_DEPS)
	$(CC) -c $(CFLAGS) -UDOUBLE -DMINUS $< -o ../$(@F)

../zlaswp_plus.$(SUFFIX) : $(ZLASWP) $(ZLASWP_DEPS)
	$(CC) -c $(CFLAGS) -DDOUBLE -UMINUS $< -o ../$(@F)

../zlaswp_minus.$(SUFFIX) : $(ZLASWP) $(ZLASWP_DEPS)
	$(CC) -c $(CFLAGS) -DDOUBLE -DMINUS $< -o ../$(@F)

../xlaswp_plus.$(SUFFIX) : $(ZLASWP) $(ZLASWP_DEPS)
	$(CC) -c $(CFLAGS) -DXDOUBLE -UMINUS $< -o ../$(@F)

../xlaswp_minus.$(SUFFIX) : $(ZLASWP) $(ZLASWP_DEPS)
	$(CC) -c $(CFLAGS) -DXDOUBLE -DMINUS $< -o ../$(@F)

../slaswp_plus.$(PSUFFIX) : $(LASWP)
	$(CC) -c $(PFLAGS) -UDOUBLE -UMINUS $< -o ../$(@F)

../slaswp_minus.$(PSUFFIX) : $(LASWP)
	$(CC) -c $(PFLAGS) -UDOUBLE -DMINUS $< -o ../$(@F)

../dlaswp_plus.$(PSUFFIX) : $(LASWP)
	$(CC) -c $(PFLAGS) -DDOUBLE -UMINUS $< -o ../$(@F)

../dlaswp_minus.$(PSUFFIX) : $(LASWP)
	$(CC) -c $(PFLAGS) -DDOUBLE -DMINUS $< -o ../$(@F)

../qlaswp_plus.$(PSUFFIX) : $(LASWP)
	$(CC) -c $(PFLAGS) -DXDOUBLE -UMINUS $< -o ../$(@F)

../qlaswp_minus.$(PSUFFIX) : $(LASWP)
	$(CC) -c $(PFLAGS) -DXDOUBLE -DMINUS $< -o ../$(@F)

../claswp_plus.$(PSUFFIX) : $(ZLASWP)
	$(CC) -c $(PFLAGS) -UDOUBLE -UMINUS $< -o ../$(@F)

../claswp_minus.$(PSUFFIX) : $(ZLASWP)
	$(CC) -c $(PFLAGS) -UDOUBLE -DMINUS $< -o ../$(@F)

../zlaswp_plus.$(PSUFFIX) : $(ZLASWP)
	$(CC) -c $(PFLAGS) -DDOUBLE -UMINUS $< -o ../$(@F)

../zlaswp_minus.$(PSUFFIX) : $(ZLASWP)
	$(CC) -c $(PFLAGS) -DDOUBLE -DMINUS $< -o ../$(@F)

../xlaswp_plus.$(PSUFFIX) : $(ZLASWP)
	$(CC) -c $(PFLAGS) -DXDOUBLE -UMINUS $< -o ../$(@F)

../xlaswp_minus.$(PSUFFIX) : $(ZLASWP)
	$(CC) -c $(PFLAGS) -DXDOUBLE -DMINUS $< -o ../$(@F)

=== debian/changelog ===
openblas (0.3.13+ds-3+rpi1) bullseye-staging; urgency=medium

  [changes brought forward from 0.2.15-1+rpi1 by Peter Michael Green <plugwash@raspbian.org> at Fri, 11 Mar 2016 23:39:32 +0000]
  * Disable arm-gcc-flags.patch which was enforcing gcc flags that are wrong
    for raspbian.

 -- Raspbian forward porter <root@raspbian.org>  Thu, 29 Apr 2021 21:08:00 +0000

openblas (0.3.13+ds-3) unstable; urgency=medium

  * fix-arm64-sigill.patch: new patch, fixes SIGILL on arm64 with numpy.
    Thanks to Thomas Viehmann <tv@beamnet.de> (Closes: #986996)

 -- Sébastien Villemot <sebastien@debian.org>  Sun, 18 Apr 2021 10:36:29 +0200

openblas (0.3.13+ds-2) unstable; urgency=medium

  [ Gianfranco Costamagna ]
  * Enable dynamic arch support on s390x. (LP: #1893653) (Closes: #981048)
    + Also change control file references, thanks Marius Hillenbrand (mhillen)

  [ Aurelien Jarno ]
  * Enable support for riscv64 (Closes: #978633)

 -- Mo Zhou <lumin@debian.org>  Wed, 27 Jan 2021 13:56:54 +0800

openblas (0.3.13+ds-1) unstable; urgency=medium

  * New upstream version 0.3.13+ds
  * d/copyright: reflect upstream changes
  * reunify-arm64-buffersize.patch: drop patch, applied upstream
  * Bump S-V to 4.5.1

 -- Sébastien Villemot <sebastien@debian.org>  Thu, 17 Dec 2020 13:53:00 +0100

openblas (0.3.12+ds-2) unstable; urgency=medium

  * reunify-arm64-buffersize.patch: new patch from upstream (Closes: #970558)

 -- Sébastien Villemot <sebastien@debian.org>  Sun, 01 Nov 2020 10:47:26 +0100

openblas (0.3.12+ds-1) unstable; urgency=medium

  * New upstream version 0.3.12+ds
  * fix-dynamic-arch-gemm-crashes.patch: drop patch, applied upstream

 -- Sébastien Villemot <sebastien@debian.org>  Mon, 26 Oct 2020 17:52:08 +0100
